SystemOrganization addCategory: #TusLibros!

Object subclass: #Book
	instanceVariableNames: 'isbn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Book class methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/27/2013 21:56'!
withISBN: anIsbn
	^ self new initializeWithISBN: anIsbn ! !

!Book methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/27/2013 21:47'!
= aBook 
	^ isbn = isbn! !

!Book methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/27/2013 21:48'!
hash
	^ isbn hash! !

!Book methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/27/2013 21:49'!
initializeWithISBN: anIsbn
	isbn := anIsbn ! !

Object subclass: #Cart
	instanceVariableNames: 'books'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/27/2013 21:16'!
create
	^ EmptyCart new! !

!Cart methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 5/27/2013 21:23'!
add: aBook
	^ self subclassResponsibility ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/27/2013 21:36'!
contains: aBook
	^ self subclassResponsibility ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/27/2013 21:17'!
isEmpty
	^ self subclassResponsibility ! !

Cart subclass: #EmptyCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!EmptyCart methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 5/27/2013 21:43'!
add: aBook
	^ self become: (NonEmptyCart withFirstBook: aBook)! !

!EmptyCart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/27/2013 21:37'!
contains: aBook
	^ false! !

!EmptyCart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/27/2013 21:18'!
isEmpty
	^ true! !

Cart subclass: #NonEmptyCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!NonEmptyCart class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/27/2013 21:40'!
withFirstBook: aBook
	^ self new initializeWithFirstBook: aBook! !

!NonEmptyCart methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 5/27/2013 21:32'!
add: aBook
	books at: aBook ifPresent: [ :aValue | books at: aBook put: aValue + 1] ifAbsent: [ books at: aBook put: 1 ]! !

!NonEmptyCart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/27/2013 21:39'!
contains: aBook
	^ books includes: aBook! !

!NonEmptyCart methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/27/2013 21:35'!
initializeWithFirstBook: aBook
	books := Dictionary new.
	self add: aBook.! !

!NonEmptyCart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/27/2013 21:25'!
isEmpty
	^ false! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/27/2013 21:36'!
test1NewCartShouldBeEmpty
	self assert: Cart create isEmpty! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/27/2013 21:53'!
test2BookShouldBePresentAfterBeingAdded
	|aCart aBook|
	aCart:= Cart create.
	aBook:= Book withISBN: '12345-67'.
	aCart add: aBook.
	
	self assert: (aCart contains: aBook)! !
